function grains = identifygrains2_ellipse_int2(F,E,topedge,bottomedge,rightedge,leftedge,figureson)


%F is a label matrix. elements=0 are interstices, elements with numbers
%belong to the object (grain) identified by that number. max(F) should be
%the number of grains identified.
%replace grain id's on the edges with 0, if we are eliminating edges:
[r,c] = size(F);
mask = zeros(size(F));
if topedge == 1
    mask(1,:) = 1;
end
if bottomedge == 1
    mask(r,:) = 1;
end
if leftedge == 1
    mask(:,1) = 1;
end
if rightedge == 1
    mask(:,c) = 1;
end
edges = mask.*F;
edges = reshape(edges,[],1);
zeroinds = find(edges == 0);
edges(zeroinds) = [];
fprintf(1,'found edge regions\n');
Fedges = ismember(F,edges);
F(Fedges == 1) = 0;
fprintf(1,'finished modifying edges\n');

% edges = unique(edges);
% 
% for i=1:length(edges)
%     if edges(i) ~= 0
%         aa = find(F == edges(i));
%         F(aa) = 0;
%     end
% end
% fprintf(1,'finished modifying edge regions\n');
    

% [r,c]=size(F);
% for i=1:max(max(F))
%     [r2,c2]=find(F==i);
%     if topedge == 1
%         zz = find(r2==1);
%         if isempty(zz) == 0 % if object is at edge
%             S=sparse(r2,c2,1,r,c); %makes sparse matrix with 1 at r2 and c2
%             S=full(S); %convert to reg matrix
%             S=logical(S); %convert to logical
%             S=~S; %complement, now everything but elements of object i are 1
%             F=S.*F; %should replace object i elements with 0
%             continue
%         end
%     end
%     fprintf(1, 'finished top\n');
%     if bottomedge == 1
%         zz = find(r2==max(r));
%         if isempty(zz) == 0 % if object is at edge
%             S=sparse(r2,c2,1,r,c); %makes sparse matrix with 1 at r2 and c2
%             S=full(S); %convert to reg matrix
%             S=logical(S); %convert to logical
%             S=~S; %complement, now everything but elements of object i are 1
%             F=S.*F; %should replace object i elements with 0
%             continue
%         end
%     end
%     fprintf(1, 'finished bottom\n');
%     if leftedge == 1
%         zz = find(c2==1);
%         if isempty(zz) == 0 % if object is at edge
%             S=sparse(r2,c2,1,r,c); %makes sparse matrix with 1 at r2 and c2
%             S=full(S); %convert to reg matrix
%             S=logical(S); %convert to logical
%             S=~S; %complement, now everything but elements of object i are 1
%             F=S.*F; %should replace object i elements with 0
%             continue
%         end
%     end
%     fprintf(1, 'finished left\n');
%     if rightedge == 1
%         zz = find(c2==max(c));
%         if isempty(zz) == 0 % if object is at edge
%             S=sparse(r2,c2,1,r,c); %makes sparse matrix with 1 at r2 and c2
%             S=full(S); %convert to reg matrix
%             S=logical(S); %convert to logical
%             S=~S; %complement, now everything but elements of object i are 1
%             F=S.*F; %should replace object i elements with 0
%             continue
%         end
%     end
%     fprintf(1, 'finished right\n');
% end
%for some reason, watershed on its own gets rid of the 'thick' parts of the
%edge map after double threshold analysis, so all interstices are 1 pixel
%wide. The following lines of code are meant to combine the edges from the
%previous step with the watershed edges.
Fold = F; %preserve prior version, if wanted later
[m,n]=size(F);
[r,c]=find(E==1);
S=sparse(r,c,1,m,n); 
S=full(S);
S=logical(S);
S=~S; 
F=S.*F;

if figureson == 1
    figure, imshow(F); 
    title(strcat(imagename,', step 5: after watershed'),'Interpreter','none');
end
fprintf(1,'Finished adjusting watershed\n');

%make an overlay of the watershed on the origina b/w image
if figureson == 1
    out_red = A;
    out_green = A;
    out_blue = A;
    F2 = ~F;
    out_red(F2) = 255;
    out_green(F2) = 255;
    out_blue(F2) = 0;
    G = cat(3, out_red, out_green, out_blue);
    figure, imshow(G); 
    title(strcat(imagename,', watershed over original b/w image'),'Interpreter','none');
end

%measure grain sizes for objects identified in watershed segmentation
stats = regionprops(F, 'Centroid', 'MinorAxisLength','MajorAxisLength','Orientation');
fprintf(1,'Finished regionprops\n');
%stats will have lots of grains with minoraxislength=0 and centroid [NaN
%NaN] if the edges are removed in the previous step.
%make a grains = [id x_centroid y_centroid MinorAxisLength] matrix
jj=1;
for i=1:length(stats)
    if stats(i).MinorAxisLength ~= 0
        grains(jj,1) = i;
        grains(jj,2:3) = stats(i).Centroid;
        grains(jj,4) = stats(i).MinorAxisLength/pixpermm;
        grains(jj,5) = stats(i).MajorAxisLength/pixpermm;
        grains(jj,6) = stats(i).Orientation;
        jj=jj+1;
    end
end
fprintf(1,'finished writing grains\n');