function [cdfnew,Dnew] = truncategsd(cdf1,D1,lowertrunc,uppertrunc)

if nargin<4
    uppertrunc = max(D1);
end

cdf1 = sort(cdf1,'ascend');
D1 = sort(D1,'ascend');

goodindices = find(D1 >= lowertrunc & D1 <= uppertrunc);

%renormalize cdf values now that the unwanted tails have been removed
%first find the percent finer corresponding to the truncation points

phi1 = log2(D1);
lowphi = log2(lowertrunc);
highphi = log2(uppertrunc);
if min(D1) > lowertrunc
    cdflow = 0;
else
    cdflow = interp1(phi1,cdf1,lowphi);
end
if max(D1) < uppertrunc
    cdfhigh = 100;
else
    cdfhigh = interp1(phi1,cdf1,highphi);
end

%force D values at the truncation points, if they don't already exist
lowindex = find(D1 == lowertrunc);
if isempty(lowindex) == 1
    Dtemp(1,1) = lowertrunc;
    cdftemp(1,1) = cdflow;
    Dtemp(2:length(goodindices)+1,1) = D1(goodindices);
    cdftemp(2:length(goodindices)+1,1) = cdf1(goodindices);
else 
    Dtemp = D1(goodindices);
    cdftemp = cdf1(goodindices);
end
highindex = find(D1 == uppertrunc);
if isempty(highindex) == 1
    Dtemp(length(Dtemp)+1,1) = uppertrunc;
    cdftemp(length(cdftemp)+1,1) = cdfhigh;
end

%renormalize cdftemp
cdftemp = cdftemp - cdftemp(1);
cdfnew = cdftemp./cdftemp(length(cdftemp)).*100;
Dnew = Dtemp;
